code_start = $1001

.org code_start-2
	.word code_start; for the .prg file

;BASIC:	 2003 sys4109

	.word :+,2003
	.byte $9e	; sys token
	.byte "4109"
:	.byte 0,0,0


p = $02

.proc	main

	sei
	sta $ff3f

	jsr copyFliData

	lda #<fliSpeedcode
	sta <p
	lda #>fliSpeedcode
	sta <(p+1)
	jsr makeFliSpeedcode

	lda $ff07
	and #$e0
	ora #$18
	sta ff07_tab
	ora #1
	sta ff07_tab+1

	jsr initIrq

	lda #0
	sta $ff19

	jmp *
.endproc

gr_mode_06 = $38

screen00 = $2000
screen01 = $2800
screen02 = $3000
screen03 = $3800

screen10 = $4000
screen11 = $4800
screen12 = $5000
screen13 = $5800
bitmap0 = $6000
bitmap1 = $8000
ff15_tab = $a000



.proc	initIrq

	lda #$00
	sta $ff0b
	lda #$02
	sta $ff0a
	lda #<irq
	sta $fffe
	lda #>irq
	sta $ffff
	lda $ff09
	sta $ff09
	cli
	rts

irq:
	sta temp_a
	lda $ff1e	;stabilizaljuk a rasztert
	lsr
	lsr
	sta reljump
reljump = *+1
	bpl *+2
	cmp #$c9
	cmp #$c9
	cmp #$c9
	cmp #$c9
	cmp #$c9
	cmp #$c5
	nop
	; stabil!
	stx temp_x
	sty temp_y
	
fliRoutine:
	bit $ffff
	bit $ffff
	bit $ffff
	bit $ffff
	bit $ffff
	bit $ffff
	bit $ffff
	bit $ffff
	bit $ffff
	bit $ffff
	bit $ffff
	bit $ffff
	bit $ffff
	bit $ffff
	bit $00

xflick = *+1
	lda #1
	eor #1
	sta xflick
	tax
	lda ff07_tab,x
	sta $ff07

	lda ff12_tab,x
	sta $ff12

	lda $fc
	pha
	lda $fd
	pha
	lda $fe
	pha
	lda $ff
	pha
	
	lda colorRamTab,x
	sta $fc
	lda colorRamTab+2,x
	sta $fd
	lda colorRamTab+4,x
	sta $fe
	lda colorRamTab+6,x
	sta $ff
	
	jsr fliSpeedcode

	lda ff06_tab
	sta $ff06
	
	pla
	sta $ff
	pla
	sta $fe
	pla
	sta $fd
	pla
	sta $fc

	lda $ff09
	sta $ff09
temp_a = *+1
	lda #0
temp_x = *+1
	ldx #0
temp_y = *+1
	ldy #0
	rti

.endproc



.proc	makeFliSpeedcode

	ldy #0
	sty ycount

c:	ldx #10
	tya
	and #1
	bne copy
	tya
	and #7
	lsr
	tax
	lda ff14_tab,x
	sta ff14r
	lda ff06_tab,x
	sta ff06r
	ldx #0
copy:	ldy #255
:	iny
	lda sample_beg,x
	sta (p),y
	inx
	cpx #<(sample_end-sample_beg)
	bne :-
	tya
	clc
	adc <p
	sta <p
	bcc :+
	inc <(p+1)

:	clc
	lda rff15
	adc #4
	sta rff15
	bcc :+
	inc rff15+1
:	clc
	lda rff15
	adc #2
	sta rff16
	lda rff15+1
	adc #0
	sta rff16+1

	inc ycount
ycount=*+1
	ldy #0 
	cpy #200
	bne c
	rts


sample_beg:

ff06r = *+1
	lda #00
ff14r = *+1
	ldy $00
	sta $ff06
	sty $ff14

rff15 = *+1
	lda ff15_tab,x
rff16 = *+1
	ldy ff15_tab+2,x
	sta $ff15
	sty $ff16

	rts

sample_end:

.endproc


ff06_tab: 
	.byte gr_mode_06 + 3
	.byte gr_mode_06 + 5
	.byte gr_mode_06 + 7
	.byte gr_mode_06 + 1

ff14_tab: .byte $fc, $fd, $fe, $ff

ff07_tab: .byte 8,9

ff12_tab: .byte bitmap0/1024,bitmap1/1024

colorRamTab:
	.byte >screen00,>screen10
	.byte >screen01,>screen11
	.byte >screen02,>screen12
	.byte >screen03,>screen13


fliSpeedcode:


.proc	copyFliData

	lda #<fliData
	sta $d0
	lda #($83 + >fliData)
	sta $d1
	ldy #0
	sty $d2
	lda #$a3
	sta $d3
	ldx #$84
l:	lda ($d0),y
	sta ($d2),y
	iny
	bne l
	dec $d1
	dec $d3
	dex
	bne l
	rts
.endproc


fliData: